<?php
require_once('XML/RPC/Server.php');
require_once('./mt2mixi.cfg');
$GLOBALS['XML_RPC_defencoding'] = "UTF-8";
mb_language("ja");
mb_internal_encoding(MT2MIXI_ENTRY_CHARSET);

function weblogUpdates($msg) {
  for ($i = 0; $i < $msg->getNumParams(); $i++) {
    if ($i == 0) {
      $ping_title = $msg->getParam($i);
      $ping_title = $ping_title->scalarval();
    } else if ($i == 1) {
      $ping_url = $msg->getParam($i);
      $ping_url = $ping_url->scalarval();
    } else if ($i == 2) {
      $ping_change_url = $msg->getParam($i);
      $ping_change_url = $ping_change_url->scalarval();
    } else if ($i == 3) {
      $ping_category = $msg->getParam($i);
      $ping_category = $ping_cateogry->scalarval();
    }
  }

  if (strcmp(BLOG_URL, $ping_url)) {
    $value = new XML_RPC_Value(
      array(
        "flerror" => new XML_RPC_Value(1, "boolean"),
        "message" => new XML_RPC_Value("You are not allowed to ping.")),
      "struct");
    return new XML_RPC_Response($value);
  }

  /* get recent entry from entry file */
  $postid = "";
  $subject = "";
  $body = "";
  $flag = 0;
  $fp = fopen(MT2MIXI_ENTRY, 'r');
  if (!$fp) {
    $value = new XML_RPC_Value(
      array(
        "flerror" => new XML_RPC_Value(1, "boolean"),
        "message" => new XML_RPC_Value("Fail to open entry file.")),
      "struct");
    return new XML_RPC_Response($value);
  }
  while (!feof($fp)) {
    $buf = fgets($fp);
    if ($flag == 0 && trim($buf) != "") {
      $postid = trim($buf);
      $flag = 1;
    } else if ($flag == 1 && trim($buf) != "") {
      $subject = rtrim($buf);
      $flag = 2;
    } else if ($flag == 2 && trim($buf) != "") {
      $body = $body . $buf;
      $flag = 3;
    } else if ($flag == 3) {
      $body = $body . $buf;
    }
  }
  fclose($fp);

  if (file_exists(MT2MIXI_DAT)) {
    $dat = fopen(MT2MIXI_DAT, 'r');
    $id = trim(fgets($dat));
    fclose($dat);
    if ($id == $postid) {
      $value = new XML_RPC_Value(
        array(
          "flerror" => new XML_RPC_Value(1, "boolean"),
          "message" => new XML_RPC_Value("I've already received this ping.")),
        "struct");
      return new XML_RPC_Response($value);
    } else {
      $dat = fopen(MT2MIXI_DAT, 'w');
      fputs($dat, $postid);
      fclose($dat);
    }
  }

  /* post to mixi */
  $from = "From: " . mb_encode_mimeheader(MIXI_MAIL_FROM);
  $to = mb_encode_mimeheader(MIXI_MAIL_TO);
  $result = mb_send_mail($to, $subject, $body, $from);
  if (!$result) {
    $value = new XML_RPC_Value(
      array(
        "flerror" => new XML_RPC_Value(1, "boolean"),
        "message" => new XML_RPC_Value("Fail to send mail.")),
      "struct");
    return new XML_RPC_Response($value);
  }

  /* response */
  $value = new XML_RPC_Value(
    array(
      "flerror" => new XML_RPC_Value(0, "boolean"),
      "message" => new XML_RPC_Value("Thanks for the ping.")),
    "struct");
  return new XML_RPC_Response($value);
}

$map = array("weblogUpdates.ping" => array("function" => "weblogUpdates"));
$server =& new XML_RPC_Server($map);

exit(0);
?>
